package com.hzya.frame.plugin.grp.service.impl;

import cn.hutool.core.lang.Assert;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.grpU8.nxproof.gzlwfml.service.IGzLwfExtService;
import com.hzya.frame.plugin.grp.service.ILwfPluginService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;

/**
 * @Description 劳务费插件
 * @Author xiangerlin
 * @Date 2025/5/13 17:52
 **/
public class LwfPluginServiceImpl implements ILwfPluginService {
    Logger logger = LoggerFactory.getLogger(ILwfPluginService.class);
    @Autowired
    private IGzLwfExtService lwfExtService;
    @Value("${zt.url}")
    private String interfaceUrl;
    /**
     * 执行插件
     *
     * @param json
     * @return
     */
    @Override
    public JsonResultEntity execute(JSONObject json) throws Exception {
        String headersStr = json.getString("headers");//请求头
        String formAppId = json.getString("formAppId");
        String eventType = json.getString("eventType");
        String dataSouceCode = json.getString("apiDataSourceCode");
        Assert.notEmpty(formAppId,"formAppId不能为空");
        Assert.notEmpty(eventType,"eventType不能为空");
        Assert.notEmpty(headersStr,"headers不能为空");
        Assert.notEmpty(dataSouceCode,"数据源编码不能为空");
        logger.info("准备开始组装参数");
        String param = lwfExtService.saveLwfPrePlugin(json);
        logger.info("OA单据组装好准备保存劳务费的参数:{}",param);
        String result = HttpRequest.post(interfaceUrl)
                .header("appId","800042")// grp应用
                .header("apiCode","8000420043")//劳务费接口
                .header("publicKey","ZJYAcDv1SMgN1oUwzfpV5byfUaN78sVw+L+DB9XTT30aS8hCe7eDIk+3zDUT+v578prj")//OA应用key
                .header("secretKey","ZLQWG13Z30FoeuCgi6/Uc41XF6oLO63550OAa6ggXUmtOZj5MgQNZMjVgL/M4BRkj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=")//OA应用密钥
                .body(param).execute().body();
        // JsonResultEntity resultEntity = (JsonResultEntity) oerDjmlService.handleOerDjml(paramJSON);
        // logger.info("保存GRPU8响应参数:{}",JSONObject.toJSON(resultEntity));
        logger.info("保存GRPU8响应参数:{}",result);
        return BaseResult.getSuccessMessageEntity(result);
    }
}
